Revert "preprocessor/58580 - preprocessor goes OOM with warning for zero literals"
[official-gcc.git] / libgo / mksysinfo.sh
bloba1713df9b572e75f41024b5223915c0bdfcffaae
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
22 set -e
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
163 #if defined(HAVE_NETINET_ICMP6_H)
164 #include <netinet/icmp6.h>
165 #endif
167 /* Constants that may only be defined as expressions on some systems,
168 expressions too complex for -fdump-go-spec to handle. These are
169 handled specially below. */
170 enum {
171 #ifdef TIOCGWINSZ
172 TIOCGWINSZ_val = TIOCGWINSZ,
173 #endif
174 #ifdef TIOCNOTTY
175 TIOCNOTTY_val = TIOCNOTTY,
176 #endif
177 #ifdef TIOCSCTTY
178 TIOCSCTTY_val = TIOCSCTTY,
179 #endif
183 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
185 echo 'package syscall' > ${OUT}
186 echo 'import "unsafe"' >> ${OUT}
187 echo 'type _ unsafe.Pointer' >> ${OUT}
189 # Get all the consts and types, skipping ones which could not be
190 # represented in Go and ones which we need to rewrite. We also skip
191 # function declarations, as we don't need them here. All the symbols
192 # will all have a leading underscore.
193 grep -v '^// ' gen-sysinfo.go | \
194 grep -v '^func' | \
195 grep -v '^type _timeval ' | \
196 grep -v '^type _timespec_t ' | \
197 grep -v '^type _timespec ' | \
198 grep -v '^type _timestruc_t ' | \
199 grep -v '^type _epoll_' | \
200 grep -v 'in6_addr' | \
201 grep -v 'sockaddr_in6' | \
202 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
203 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
204 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
205 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
206 >> ${OUT}
208 # The errno constants. These get type Errno.
209 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
210 egrep '#define E[A-Z0-9_]+ ' | \
211 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
213 # The O_xxx flags.
214 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
215 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
216 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
217 echo "const O_ASYNC = 0" >> ${OUT}
219 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
220 echo "const O_CLOEXEC = 0" >> ${OUT}
223 # These flags can be lost on i386 GNU/Linux when using
224 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
225 # before we see the definition of F_SETLK64.
226 for flag in F_GETLK F_SETLK F_SETLKW; do
227 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
228 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
229 echo "const ${flag} = ${flag}64" >> ${OUT}
231 done
233 # The signal numbers.
234 grep '^const _SIG[^_]' gen-sysinfo.go | \
235 grep -v '^const _SIGEV_' | \
236 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
237 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
238 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
239 echo "const SIGPOLL = SIGIO" >> ${OUT}
242 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
243 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
244 echo "const SIGCLD = SIGCHLD" >> ${OUT}
248 # The syscall numbers. We force the names to upper case.
249 grep '^const _SYS_' gen-sysinfo.go | \
250 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
251 while read sys; do
252 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
253 echo "const $sup = _$sys" >> ${OUT}
254 done
256 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
257 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
258 echo "const SYS_GETDENTS = 0" >> ${OUT}
260 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
261 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
264 # Stat constants.
265 grep '^const _S_' gen-sysinfo.go | \
266 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
268 # Mmap constants.
269 grep '^const _PROT_' gen-sysinfo.go | \
270 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
271 grep '^const _MAP_' gen-sysinfo.go | \
272 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
273 grep '^const _MADV_' gen-sysinfo.go | \
274 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
275 grep '^const _MCL_' gen-sysinfo.go | \
276 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
278 # Process status constants.
279 grep '^const _W' gen-sysinfo.go |
280 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
281 # WSTOPPED was introduced in glibc 2.3.4.
282 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
283 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
284 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
285 else
286 echo 'const WSTOPPED = 2' >> ${OUT}
289 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
290 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
291 echo 'const WALL = ___WALL' >> ${OUT}
294 # Networking constants.
295 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
296 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
297 grep '^const _SOMAXCONN' gen-sysinfo.go |
298 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
299 >> ${OUT}
300 grep '^const _SHUT_' gen-sysinfo.go |
301 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
303 # The net package requires some const definitions.
304 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
305 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
306 echo "const $m = 0" >> ${OUT}
308 done
309 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
310 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
311 echo "const $m = -1" >> ${OUT}
313 done
315 # The syscall package requires AF_LOCAL.
316 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
317 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
318 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
322 # pathconf constants.
323 grep '^const __PC' gen-sysinfo.go |
324 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
326 # The PATH_MAX constant.
327 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
328 echo 'const PathMax = _PATH_MAX' >> ${OUT}
331 # epoll constants.
332 grep '^const _EPOLL' gen-sysinfo.go |
333 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
334 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
335 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
336 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
338 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
339 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
342 # Prctl constants.
343 grep '^const _PR_' gen-sysinfo.go |
344 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
346 # Ptrace constants.
347 grep '^const _PTRACE' gen-sysinfo.go |
348 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
349 # We need some ptrace options that are not defined in older versions
350 # of glibc.
351 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
352 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
354 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
355 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
357 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
358 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
360 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
361 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
363 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
364 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
366 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
367 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
369 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
370 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
372 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
373 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
375 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
376 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
378 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
379 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
381 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
382 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
384 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
385 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
387 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
388 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
390 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
391 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
393 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
394 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
396 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
397 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
399 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
400 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
403 # The registers returned by PTRACE_GETREGS. This is probably
404 # GNU/Linux specific; it should do no harm if there is no
405 # _user_regs_struct.
406 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
407 if test "$regs" != ""; then
408 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
409 regs=`echo $regs | sed -e s'/^ *//'`
410 nregs=
411 while test -n "$regs"; do
412 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
413 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
414 # Capitalize the first character of the field.
415 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
416 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
417 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
418 field="$f$r"
419 nregs="$nregs $field;"
420 done
421 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
424 # Some basic types.
425 echo 'type Size_t _size_t' >> ${OUT}
426 echo "type Ssize_t _ssize_t" >> ${OUT}
427 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
428 echo "type Offset_t _off64_t" >> ${OUT}
429 else
430 echo "type Offset_t _off_t" >> ${OUT}
432 echo "type Mode_t _mode_t" >> ${OUT}
433 echo "type Pid_t _pid_t" >> ${OUT}
434 echo "type Uid_t _uid_t" >> ${OUT}
435 echo "type Gid_t _gid_t" >> ${OUT}
436 echo "type Socklen_t _socklen_t" >> ${OUT}
438 # The C int type.
439 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
440 if test "$sizeof_int" = "4"; then
441 echo "type _C_int int32" >> ${OUT}
442 echo "type _C_uint uint32" >> ${OUT}
443 elif test "$sizeof_int" = "8"; then
444 echo "type _C_int int64" >> ${OUT}
445 echo "type _C_uint uint64" >> ${OUT}
446 else
447 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
448 exit 1
451 # The C long type, needed because that is the type that ptrace returns.
452 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
453 if test "$sizeof_long" = "4"; then
454 echo "type _C_long int32" >> ${OUT}
455 elif test "$sizeof_long" = "8"; then
456 echo "type _C_long int64" >> ${OUT}
457 else
458 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
459 exit 1
462 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
463 # double is commented by -fdump-go-spec.
464 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
465 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
467 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
468 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
471 # The time_t type.
472 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
473 echo 'type Time_t _time_t' >> ${OUT}
476 # The time structures need special handling: we need to name the
477 # types, so that we can cast integers to the right types when
478 # assigning to the structures.
479 timeval=`grep '^type _timeval ' gen-sysinfo.go`
480 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
481 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
482 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
483 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
484 echo $timeval | \
485 sed -e 's/type _timeval /type Timeval /' \
486 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
487 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
488 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
489 if test "$timespec" = ""; then
490 # IRIX 6.5 has __timespec instead.
491 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
493 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
494 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
495 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
496 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
497 echo $timespec | \
498 sed -e 's/^type ___timespec /type Timespec /' \
499 -e 's/^type _timespec /type Timespec /' \
500 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
501 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
503 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
504 if test "$timestruc" != ""; then
505 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
506 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
507 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
508 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
509 echo $timestruc | \
510 sed -e 's/^type _timestruc_t /type Timestruc /' \
511 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
512 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
515 # The tms struct.
516 grep '^type _tms ' gen-sysinfo.go | \
517 sed -e 's/type _tms/type Tms/' \
518 -e 's/tms_utime/Utime/' \
519 -e 's/tms_stime/Stime/' \
520 -e 's/tms_cutime/Cutime/' \
521 -e 's/tms_cstime/Cstime/' \
522 >> ${OUT}
524 # The stat type.
525 # Prefer largefile variant if available.
526 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
527 if test "$stat" != ""; then
528 grep '^type _stat64 ' gen-sysinfo.go
529 else
530 grep '^type _stat ' gen-sysinfo.go
531 fi | sed -e 's/type _stat64/type Stat_t/' \
532 -e 's/type _stat/type Stat_t/' \
533 -e 's/st_dev/Dev/' \
534 -e 's/st_ino/Ino/g' \
535 -e 's/st_nlink/Nlink/' \
536 -e 's/st_mode/Mode/' \
537 -e 's/st_uid/Uid/' \
538 -e 's/st_gid/Gid/' \
539 -e 's/st_rdev/Rdev/' \
540 -e 's/st_size/Size/' \
541 -e 's/st_blksize/Blksize/' \
542 -e 's/st_blocks/Blocks/' \
543 -e 's/st_atim/Atim/' \
544 -e 's/st_mtim/Mtim/' \
545 -e 's/st_ctim/Ctim/' \
546 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
547 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
548 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
549 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
550 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
551 >> ${OUT}
553 # The directory searching types.
554 # Prefer largefile variant if available.
555 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
556 if test "$dirent" != ""; then
557 grep '^type _dirent64 ' gen-sysinfo.go
558 else
559 grep '^type _dirent ' gen-sysinfo.go
560 fi | sed -e 's/type _dirent64/type Dirent/' \
561 -e 's/type _dirent/type Dirent/' \
562 -e 's/d_name \[0+1\]/d_name [0+256]/' \
563 -e 's/d_name/Name/' \
564 -e 's/]int8/]byte/' \
565 -e 's/d_ino/Ino/' \
566 -e 's/d_off/Off/' \
567 -e 's/d_reclen/Reclen/' \
568 -e 's/d_type/Type/' \
569 >> ${OUT}
570 echo "type DIR _DIR" >> ${OUT}
572 # Values for d_type field in dirent.
573 grep '^const _DT_' gen-sysinfo.go |
574 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
576 # The rusage struct.
577 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
578 if test "$rusage" != ""; then
579 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
580 rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
581 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
582 rusage=`echo $rusage | sed -e 's/^ *//'`
583 nrusage=
584 while test -n "$rusage"; do
585 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
586 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
587 # Drop the leading ru_, capitalize the next character.
588 field=`echo $field | sed -e 's/^ru_//'`
589 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
590 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
591 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
592 # Fix _timeval _timespec, and _timestruc_t.
593 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
594 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
595 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
596 field="$f$r"
597 nrusage="$nrusage $field;"
598 done
599 echo "type Rusage struct {$nrusage }" >> ${OUT}
600 else
601 echo "type Rusage struct {}" >> ${OUT}
604 # The RUSAGE constants.
605 grep '^const _RUSAGE_' gen-sysinfo.go | \
606 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
608 # The utsname struct.
609 grep '^type _utsname ' gen-sysinfo.go | \
610 sed -e 's/_utsname/Utsname/' \
611 -e 's/sysname/Sysname/' \
612 -e 's/nodename/Nodename/' \
613 -e 's/release/Release/' \
614 -e 's/version/Version/' \
615 -e 's/machine/Machine/' \
616 -e 's/domainname/Domainname/' \
617 >> ${OUT}
619 # The iovec struct.
620 iovec=`grep '^type _iovec ' gen-sysinfo.go`
621 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
622 echo "type Iovec_len_t $iovec_len" >> ${OUT}
623 echo $iovec | \
624 sed -e 's/_iovec/Iovec/' \
625 -e 's/iov_base/Base/' \
626 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
627 >> ${OUT}
629 # The msghdr struct.
630 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
631 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
632 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
633 echo $msghdr | \
634 sed -e 's/_msghdr/Msghdr/' \
635 -e 's/msg_name/Name/' \
636 -e 's/msg_namelen/Namelen/' \
637 -e 's/msg_iov/Iov/' \
638 -e 's/msg_iovlen/Iovlen/' \
639 -e 's/_iovec/Iovec/' \
640 -e 's/msg_control/Control/' \
641 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
642 -e 's/msg_flags/Flags/' \
643 >> ${OUT}
645 # The MSG_ flags for Msghdr.
646 grep '^const _MSG_' gen-sysinfo.go | \
647 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
649 # The cmsghdr struct.
650 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
651 if test -n "$cmsghdr"; then
652 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
653 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
654 echo "$cmsghdr" | \
655 sed -e 's/_cmsghdr/Cmsghdr/' \
656 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
657 -e 's/cmsg_level/Level/' \
658 -e 's/cmsg_type/Type/' \
659 -e 's/\[\]/[0]/' \
660 >> ${OUT}
663 # The SCM_ flags for Cmsghdr.
664 grep '^const _SCM_' gen-sysinfo.go | \
665 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
667 # The ucred struct.
668 grep '^type _ucred ' gen-sysinfo.go | \
669 sed -e 's/_ucred/Ucred/' \
670 -e 's/pid/Pid/' \
671 -e 's/uid/Uid/' \
672 -e 's/gid/Gid/' \
673 >> ${OUT}
675 # The ip_mreq struct.
676 grep '^type _ip_mreq ' gen-sysinfo.go | \
677 sed -e 's/_ip_mreq/IPMreq/' \
678 -e 's/imr_multiaddr/Multiaddr/' \
679 -e 's/imr_interface/Interface/' \
680 -e 's/_in_addr/[4]byte/g' \
681 >> ${OUT}
683 # We need IPMreq to compile the net package.
684 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
685 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
688 # The ipv6_mreq struct.
689 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
690 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
691 -e 's/ipv6mr_multiaddr/Multiaddr/' \
692 -e 's/ipv6mr_interface/Interface/' \
693 -e 's/_in6_addr/[16]byte/' \
694 >> ${OUT}
696 # We need IPv6Mreq to compile the net package.
697 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
698 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
701 # The ip_mreqn struct.
702 grep '^type _ip_mreqn ' gen-sysinfo.go | \
703 sed -e 's/_ip_mreqn/IPMreqn/' \
704 -e 's/imr_multiaddr/Multiaddr/' \
705 -e 's/imr_address/Address/' \
706 -e 's/imr_ifindex/Ifindex/' \
707 -e 's/_in_addr/[4]byte/g' \
708 >> ${OUT}
710 # We need IPMreq to compile the net package.
711 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
712 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
715 # The icmp6_filter struct.
716 grep '^type _icmp6_filter ' gen-sysinfo.go | \
717 sed -e 's/_icmp6_filter/ICMPv6Filter/' \
718 -e 's/data/Data/' \
719 -e 's/filt/Filt/' \
720 >> ${OUT}
722 # We need ICMPv6Filter to compile the syscall package.
723 if ! grep 'type ICMPv6Filter ' ${OUT} > /dev/null 2>&1; then
724 echo 'type ICMPv6Filter struct { Data [8]uint32 }' >> ${OUT}
727 # Try to guess the type to use for fd_set.
728 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
729 fds_bits_type="_C_long"
730 if test "$fd_set" != ""; then
731 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
733 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
735 # The addrinfo struct.
736 grep '^type _addrinfo ' gen-sysinfo.go | \
737 sed -e 's/_addrinfo/Addrinfo/g' \
738 -e 's/ ai_/ Ai_/g' \
739 >> ${OUT}
741 # The addrinfo flags and errors.
742 grep '^const _AI_' gen-sysinfo.go | \
743 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
744 grep '^const _EAI_' gen-sysinfo.go | \
745 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
747 # The passwd struct.
748 grep '^type _passwd ' gen-sysinfo.go | \
749 sed -e 's/_passwd/Passwd/' \
750 -e 's/ pw_/ Pw_/g' \
751 >> ${OUT}
753 # The ioctl flags for the controlling TTY.
754 grep '^const _TIOC' gen-sysinfo.go | \
755 grep -v '_val =' | \
756 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
757 # We need TIOCGWINSZ.
758 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
759 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
760 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
763 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
764 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
765 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
768 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
769 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
770 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
774 # The ioctl flags for terminal control
775 grep '^const _TC[GS]ET' gen-sysinfo.go | \
776 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
778 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
779 # needs handling in syscalls.exec.go.
780 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
781 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
782 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
786 # The nlmsghdr struct.
787 grep '^type _nlmsghdr ' gen-sysinfo.go | \
788 sed -e 's/_nlmsghdr/NlMsghdr/' \
789 -e 's/nlmsg_len/Len/' \
790 -e 's/nlmsg_type/Type/' \
791 -e 's/nlmsg_flags/Flags/' \
792 -e 's/nlmsg_seq/Seq/' \
793 -e 's/nlmsg_pid/Pid/' \
794 >> ${OUT}
796 # The nlmsg flags and operators.
797 grep '^const _NLM' gen-sysinfo.go | \
798 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
800 # NLMSG_HDRLEN is defined as an expression using sizeof.
801 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
802 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
803 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
807 # The rtmsg struct.
808 grep '^type _rtmsg ' gen-sysinfo.go | \
809 sed -e 's/_rtmsg/RtMsg/' \
810 -e 's/rtm_family/Family/' \
811 -e 's/rtm_dst_len/Dst_len/' \
812 -e 's/rtm_src_len/Src_len/' \
813 -e 's/rtm_tos/Tos/' \
814 -e 's/rtm_table/Table/' \
815 -e 's/rtm_protocol/Protocol/' \
816 -e 's/rtm_scope/Scope/' \
817 -e 's/rtm_type/Type/' \
818 -e 's/rtm_flags/Flags/' \
819 >> ${OUT}
821 # The rtgenmsg struct.
822 grep '^type _rtgenmsg ' gen-sysinfo.go | \
823 sed -e 's/_rtgenmsg/RtGenmsg/' \
824 -e 's/rtgen_family/Family/' \
825 >> ${OUT}
827 # The routing message flags.
828 grep '^const _RT_' gen-sysinfo.go | \
829 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
830 grep '^const _RTA' gen-sysinfo.go | \
831 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
832 grep '^const _RTF' gen-sysinfo.go | \
833 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
834 grep '^const _RTCF' gen-sysinfo.go | \
835 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
836 grep '^const _RTM' gen-sysinfo.go | \
837 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
838 grep '^const _RTN' gen-sysinfo.go | \
839 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
840 grep '^const _RTPROT' gen-sysinfo.go | \
841 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
843 # The ifinfomsg struct.
844 grep '^type _ifinfomsg ' gen-sysinfo.go | \
845 sed -e 's/_ifinfomsg/IfInfomsg/' \
846 -e 's/ifi_family/Family/' \
847 -e 's/ifi_type/Type/' \
848 -e 's/ifi_index/Index/' \
849 -e 's/ifi_flags/Flags/' \
850 -e 's/ifi_change/Change/' \
851 >> ${OUT}
853 # The interface information types and flags.
854 grep '^const _IFA' gen-sysinfo.go | \
855 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
856 grep '^const _IFLA' gen-sysinfo.go | \
857 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
858 grep '^const _IFF' gen-sysinfo.go | \
859 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
860 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
861 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
862 grep '^const _SIOC' gen-sysinfo.go |
863 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
865 # The ifaddrmsg struct.
866 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
867 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
868 -e 's/ifa_family/Family/' \
869 -e 's/ifa_prefixlen/Prefixlen/' \
870 -e 's/ifa_flags/Flags/' \
871 -e 's/ifa_scope/Scope/' \
872 -e 's/ifa_index/Index/' \
873 >> ${OUT}
875 # The rtattr struct.
876 grep '^type _rtattr ' gen-sysinfo.go | \
877 sed -e 's/_rtattr/RtAttr/' \
878 -e 's/rta_len/Len/' \
879 -e 's/rta_type/Type/' \
880 >> ${OUT}
882 # The in_pktinfo struct.
883 grep '^type _in_pktinfo ' gen-sysinfo.go | \
884 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
885 -e 's/ipi_ifindex/Ifindex/' \
886 -e 's/ipi_spec_dst/Spec_dst/' \
887 -e 's/ipi_addr/Addr/' \
888 -e 's/_in_addr/[4]byte/g' \
889 >> ${OUT}
891 # The in6_pktinfo struct.
892 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
893 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
894 -e 's/ipi6_addr/Addr/' \
895 -e 's/ipi6_ifindex/Ifindex/' \
896 -e 's/_in6_addr/[16]byte/' \
897 >> ${OUT}
899 # The termios struct.
900 grep '^type _termios ' gen-sysinfo.go | \
901 sed -e 's/_termios/Termios/' \
902 -e 's/c_iflag/Iflag/' \
903 -e 's/c_oflag/Oflag/' \
904 -e 's/c_cflag/Cflag/' \
905 -e 's/c_lflag/Lflag/' \
906 -e 's/c_line/Line/' \
907 -e 's/c_cc/Cc/' \
908 -e 's/c_ispeed/Ispeed/' \
909 -e 's/c_ospeed/Ospeed/' \
910 >> ${OUT}
912 # The termios constants.
913 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
914 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
915 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
916 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
917 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
918 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
919 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
920 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
921 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
922 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
923 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
924 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
926 grep "^const _$n " gen-sysinfo.go | \
927 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
928 done
930 # The mount flags
931 grep '^const _MNT_' gen-sysinfo.go |
932 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
933 grep '^const _MS_' gen-sysinfo.go |
934 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
936 # The fallocate flags.
937 grep '^const _FALLOC_' gen-sysinfo.go |
938 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
940 # The statfs struct.
941 # Prefer largefile variant if available.
942 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
943 if test "$statfs" != ""; then
944 grep '^type _statfs64 ' gen-sysinfo.go
945 else
946 grep '^type _statfs ' gen-sysinfo.go
947 fi | sed -e 's/type _statfs64/type Statfs_t/' \
948 -e 's/type _statfs/type Statfs_t/' \
949 -e 's/f_type/Type/' \
950 -e 's/f_bsize/Bsize/' \
951 -e 's/f_blocks/Blocks/' \
952 -e 's/f_bfree/Bfree/' \
953 -e 's/f_bavail/Bavail/' \
954 -e 's/f_files/Files/' \
955 -e 's/f_ffree/Ffree/' \
956 -e 's/f_fsid/Fsid/' \
957 -e 's/f_namelen/Namelen/' \
958 -e 's/f_frsize/Frsize/' \
959 -e 's/f_flags/Flags/' \
960 -e 's/f_spare/Spare/' \
961 >> ${OUT}
963 # The timex struct.
964 timex=`grep '^type _timex ' gen-sysinfo.go || true`
965 if test "$timex" = ""; then
966 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
967 if test "$timex" != ""; then
968 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
971 if test "$timex" != ""; then
972 echo "$timex" | \
973 sed -e 's/_timex/Timex/' \
974 -e 's/modes/Modes/' \
975 -e 's/offset/Offset/' \
976 -e 's/freq/Freq/' \
977 -e 's/maxerror/Maxerror/' \
978 -e 's/esterror/Esterror/' \
979 -e 's/status/Status/' \
980 -e 's/constant/Constant/' \
981 -e 's/precision/Precision/' \
982 -e 's/tolerance/Tolerance/' \
983 -e 's/ time / Time /' \
984 -e 's/tick/Tick/' \
985 -e 's/ppsfreq/Ppsfreq/' \
986 -e 's/jitter/Jitter/' \
987 -e 's/shift/Shift/' \
988 -e 's/stabil/Stabil/' \
989 -e 's/jitcnt/Jitcnt/' \
990 -e 's/calcnt/Calcnt/' \
991 -e 's/errcnt/Errcnt/' \
992 -e 's/stbcnt/Stbcnt/' \
993 -e 's/tai/Tai/' \
994 -e 's/_timeval/Timeval/' \
995 >> ${OUT}
998 # The rlimit struct.
999 grep '^type _rlimit ' gen-sysinfo.go | \
1000 sed -e 's/_rlimit/Rlimit/' \
1001 -e 's/rlim_cur/Cur/' \
1002 -e 's/rlim_max/Max/' \
1003 >> ${OUT}
1005 # The RLIMIT constants.
1006 grep '^const _RLIMIT_' gen-sysinfo.go |
1007 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1008 grep '^const _RLIM_' gen-sysinfo.go |
1009 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1011 # The sysinfo struct.
1012 grep '^type _sysinfo ' gen-sysinfo.go | \
1013 sed -e 's/_sysinfo/Sysinfo_t/' \
1014 -e 's/uptime/Uptime/' \
1015 -e 's/loads/Loads/' \
1016 -e 's/totalram/Totalram/' \
1017 -e 's/freeram/Freeram/' \
1018 -e 's/sharedram/Sharedram/' \
1019 -e 's/bufferram/Bufferram/' \
1020 -e 's/totalswap/Totalswap/' \
1021 -e 's/freeswap/Freeswap/' \
1022 -e 's/procs/Procs/' \
1023 -e 's/totalhigh/Totalhigh/' \
1024 -e 's/freehigh/Freehigh/' \
1025 -e 's/mem_unit/Unit/' \
1026 >> ${OUT}
1028 # The ustat struct.
1029 grep '^type _ustat ' gen-sysinfo.go | \
1030 sed -e 's/_ustat/Ustat_t/' \
1031 -e 's/f_tfree/Tfree/' \
1032 -e 's/f_tinode/Tinoe/' \
1033 -e 's/f_fname/Fname/' \
1034 -e 's/f_fpack/Fpack/' \
1035 >> ${OUT}
1036 # Force it to be defined, as on some older GNU/Linux systems the
1037 # header file fails when using with <linux/filter.h>.
1038 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1039 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1042 # The utimbuf struct.
1043 grep '^type _utimbuf ' gen-sysinfo.go | \
1044 sed -e 's/_utimbuf/Utimbuf/' \
1045 -e 's/actime/Actime/' \
1046 -e 's/modtime/Modtime/' \
1047 >> ${OUT}
1049 # The LOCK flags for flock.
1050 grep '^const _LOCK_' gen-sysinfo.go |
1051 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1053 # The PRIO constants.
1054 grep '^const _PRIO_' gen-sysinfo.go | \
1055 sed -e 's/^\(const \)_\(PRIO_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1057 # The GNU/Linux LINUX_REBOOT flags.
1058 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1059 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1061 # The GNU/Linux sock_filter struct.
1062 grep '^type _sock_filter ' gen-sysinfo.go | \
1063 sed -e 's/_sock_filter/SockFilter/' \
1064 -e 's/code/Code/' \
1065 -e 's/jt/Jt/' \
1066 -e 's/jf/Jf/' \
1067 -e 's/k /K /' \
1068 >> ${OUT}
1070 # The GNU/Linux sock_fprog struct.
1071 grep '^type _sock_fprog ' gen-sysinfo.go | \
1072 sed -e 's/_sock_fprog/SockFprog/' \
1073 -e 's/len/Len/' \
1074 -e 's/filter/Filter/' \
1075 -e 's/_sock_filter/SockFilter/' \
1076 >> ${OUT}
1078 # The GNU/Linux filter flags.
1079 grep '^const _BPF_' gen-sysinfo.go | \
1080 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1082 # The GNU/Linux nlattr struct.
1083 grep '^type _nlattr ' gen-sysinfo.go | \
1084 sed -e 's/_nlattr/NlAttr/' \
1085 -e 's/nla_len/Len/' \
1086 -e 's/nla_type/Type/' \
1087 >> ${OUT}
1089 # The GNU/Linux nlmsgerr struct.
1090 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1091 sed -e 's/_nlmsgerr/NlMsgerr/' \
1092 -e 's/error/Error/' \
1093 -e 's/msg/Msg/' \
1094 -e 's/_nlmsghdr/NlMsghdr/' \
1095 >> ${OUT}
1097 # The GNU/Linux rtnexthop struct.
1098 grep '^type _rtnexthop ' gen-sysinfo.go | \
1099 sed -e 's/_rtnexthop/RtNexthop/' \
1100 -e 's/rtnh_len/Len/' \
1101 -e 's/rtnh_flags/Flags/' \
1102 -e 's/rtnh_hops/Hops/' \
1103 -e 's/rtnh_ifindex/Ifindex/' \
1104 >> ${OUT}
1106 # The GNU/Linux netlink flags.
1107 grep '^const _NETLINK_' gen-sysinfo.go | \
1108 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1109 grep '^const _NLA_' gen-sysinfo.go | \
1110 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1112 # The GNU/Linux packet socket flags.
1113 grep '^const _PACKET_' gen-sysinfo.go | \
1114 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1116 # The GNU/Linux inotify_event struct.
1117 grep '^type _inotify_event ' gen-sysinfo.go | \
1118 sed -e 's/_inotify_event/InotifyEvent/' \
1119 -e 's/wd/Wd/' \
1120 -e 's/mask/Mask/' \
1121 -e 's/cookie/Cookie/' \
1122 -e 's/len/Len/' \
1123 -e 's/name/Name/' \
1124 -e 's/\[\]/[0]/' \
1125 -e 's/\[0\]byte/[0]int8/' \
1126 >> ${OUT}
1128 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1129 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1130 sed -e 's/_in6_addr/[16]byte/' \
1131 >> ${OUT}
1133 # Struct sizes.
1134 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1135 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1136 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1137 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1138 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1139 sock_filter SockFilter sock_fprog SockFprog ucred Ucred \
1140 icmp6_filter ICMPv6Filter
1141 while test $# != 0; do
1142 nc=$1
1143 ngo=$2
1144 shift
1145 shift
1146 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1147 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1149 done
1151 # In order to compile the net package, we need some sizes to exist
1152 # even if the types do not.
1153 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1154 echo 'const SizeofIPMreq = 8' >> ${OUT}
1156 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1157 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1159 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1160 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1162 if ! grep 'const SizeofICMPv6Filter ' ${OUT} >/dev/null 2>&1; then
1163 echo 'const SizeofICMPv6Filter = 32' >> ${OUT}
1166 exit $?